"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.theme = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _core = require("@material-ui/core");

var _react2 = _interopRequireDefault(require("@mdi/react"));

var _js = require("@mdi/js");

var _icons = require("@material-ui/icons");

var _reactDropzone = _interopRequireDefault(require("react-dropzone"));

var _style = require("./assets/style");

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var StyledTableCell = (0, _core.withStyles)(function (theme) {
  return {
    head: {
      backgroundColor: theme.palette.background["default"],
      color: "#c7c7c7"
    },
    body: {
      fontSize: 11
    }
  };
})(_core.TableCell);
var StyledTableRow = (0, _core.withStyles)(function (theme) {
  return {
    root: {
      '&:nth-of-type(odd)': {
        backgroundColor: theme.palette.background["default"]
      }
    }
  };
})(_core.TableRow);
var theme = (0, _styles.createMuiTheme)({
  direction: 'rtl',
  typography: {
    fontFamily: ['tahoma', 'sans-serif'].join(','),
    useNextVariants: true
  }
});
exports.theme = theme;

function Uploader(props) {
  var _useState = (0, _react.useState)({
    files: [],
    completedIndexes: [],
    completed: 0,
    total: 0,
    page: 0,
    rowsPerPage: 5,
    processIndex: null,
    done: false
  }),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  function handleChangePage(event, newPage) {
    setState({
      page: newPage
    });
  }

  function handleChangeRowsPerPage(event) {
    setState({
      rowsPerPage: +event.target.value
    });
  }

  function onDrop(files) {
    var totalSize = 0;
    files.map(function (file) {
      totalSize += file.size;
    });
    setState(function (prevState) {
      return _objectSpread({}, prevState, {
        files: files,
        total: totalSize
      });
    });

    if (props.autoUpload) {
      uploaderHandler(null);
    }

    if (props.returnItems !== undefined) {
      return props.returnItems(state.files);
    }
  }

  function uploaderHandler(index) {
    setState(function (prevState) {
      return _objectSpread({}, prevState, {
        processIndex: index
      });
    });
    var bodyFormData = new FormData();

    if (index === null) {
      state.files.map(function (file) {
        bodyFormData.append('files', file);
      });
    } else {
      bodyFormData.append('files', state.files[index]);
    }

    _axios["default"].post(props.uploadUrl, bodyFormData, {
      onUploadProgress: function onUploadProgress(progressEvent) {
        var percentCompleted = Math.round(progressEvent.loaded * 100 / state.totalSize);
        setState(function (prevState) {
          return _objectSpread({}, prevState, {
            completed: percentCompleted
          });
        });
      }
    }).then(function (respons) {
      var cmpList = state.completedIndexes;

      if (state.files === 1) {
        if (!cmpList.find(function (item) {
          return item.name === respons.data[0];
        })) {
          cmpList.push({
            name: respons.data[0],
            code: respons.data[1]
          });
        }
      } else {
        respons.data.map(function (ary) {
          if (!cmpList.find(function (item) {
            return item.name === ary[0];
          })) {
            cmpList.push({
              name: ary[0],
              code: ary[1]
            });
          }
        });
      }

      props.showAlert ? alert('عملیات بارگزاری باموفقیت انجام شد.') : null;
      setState(function (prevState) {
        return _objectSpread({}, prevState, {
          done: true,
          completedIndexes: cmpList
        });
      });
      return props.responseStatus ? props.responseStatus(true) : null;
    })["catch"](function (errors) {
      props.showAlert ? alert('خطا در عملیات بارگزاری !') : null;
      return props.responseStatus ? props.responseStatus(false) : errors;
    });
  }

  function removeAll() {
    setState({
      files: [],
      completed: 0,
      completedIndexes: [],
      total: 0,
      page: 0,
      rowsPerPage: 5,
      processIndex: null,
      done: false
    });
    props.showAlert ? alert('همه موارد حذف شد.') : null;
  }

  function removeItem(name) {
    var array, indx, cmpList;
    array = state.files;
    indx = array.findIndex(function (item) {
      return item.name === name;
    });

    if (indx !== -1) {
      array.splice(indx, 1);
    }

    cmpList = state.completedIndexes;
    indx = cmpList.findIndex(function (item) {
      return item.name === name;
    });

    if (indx !== -1) {
      cmpList.splice(indx, 1);
    }
    /*
        if (indx!==-1) so that your file uploaded, you can
        call server side method in this section
        to remove file from server repository
     */


    setState(function (prevState) {
      return _objectSpread({}, prevState, {
        files: array,
        completedIndexes: cmpList
      });
    });
    props.showAlert ? alert("رکورد انتخابی حذف شد.") : null;
  }

  var classes = props.classes,
      minSize = props.minSize,
      maxSize = props.maxSize,
      multiple = props.multiple,
      autoUpload = props.autoUpload,
      hideButtons = props.hideButtons,
      translate = props.translate;
  var page = state.page,
      rowsPerPage = state.rowsPerPage,
      files = state.files,
      completed = state.completed,
      processIndex = state.processIndex,
      completedIndexes = state.completedIndexes;
  var styleDropzone = {
    dragActive: {
      margin: 12,
      borderRadius: 4,
      backgroundColor: "#f2fafd",
      border: "1px solid #00a5ff"
    },
    dragDeactive: {
      margin: 12,
      borderRadius: 4,
      border: "1px dashed #9c9c9c"
    }
  };
  return _react["default"].createElement(_styles.MuiThemeProvider, {
    theme: theme
  }, _react["default"].createElement("div", {
    style: {
      direction: 'rtl'
    }
  }, _react["default"].createElement(_reactDropzone["default"], {
    onDrop: onDrop,
    minSize: minSize,
    maxSize: maxSize,
    multiple: multiple
  }, function (_ref) {
    var getRootProps = _ref.getRootProps,
        getInputProps = _ref.getInputProps,
        isDragActive = _ref.isDragActive;
    return _react["default"].createElement("div", {
      className: "container"
    }, _react["default"].createElement("div", _extends({}, getRootProps({
      className: 'dropzone'
    }), {
      style: isDragActive ? styleDropzone.dragActive : styleDropzone.dragDeactive
    }), _react["default"].createElement("input", getInputProps()), isDragActive ? _react["default"].createElement("p", {
      style: {
        textAlign: 'center',
        fontSize: 11,
        color: '#9c9c9c'
      }
    }, "\u0644\u0637\u0641\u0627 \u0641\u0627\u06CC\u0644 \u0631\u0627 \u0631\u0647\u0627 \u06A9\u0646\u06CC\u062F") : _react["default"].createElement("p", {
      style: {
        textAlign: 'center',
        fontSize: 11,
        color: '#9c9c9c'
      }
    }, _react["default"].createElement("span", null, " \u0628\u0631\u0627\u06CC \u0627\u0646\u062A\u062E\u0627\u0628 \u0641\u0627\u06CC\u0644 \u06A9\u0644\u06CC\u06A9 \u06A9\u0646\u06CC\u062F."), _react["default"].createElement(_icons.CloudUpload, {
      style: {
        marginTop: 6,
        fontSize: 24
      }
    }))));
  }), _react["default"].createElement("aside", {
    style: {
      padding: 12
    }
  }, processIndex === null ? _react["default"].createElement(_core.LinearProgress, {
    variant: "determinate",
    value: completed
  }) : null, _react["default"].createElement(_core.Table, null, _react["default"].createElement(_core.TableHead, null, _react["default"].createElement(_core.TableRow, null, _react["default"].createElement(StyledTableCell, {
    align: "center"
  }, "\u0631\u062F\u06CC\u0641"), _react["default"].createElement(StyledTableCell, {
    align: "center"
  }, "\u0646\u0645\u0627\u06CC\u0647"), _react["default"].createElement(StyledTableCell, {
    align: "center"
  }, "\u0646\u0627\u0645 \u0641\u0627\u06CC\u0644"), _react["default"].createElement(StyledTableCell, {
    align: "center"
  }, "\u062D\u062C\u0645 \u0641\u0627\u06CC\u0644"), _react["default"].createElement(StyledTableCell, {
    align: "center"
  }, " "), _react["default"].createElement(StyledTableCell, {
    align: "center"
  }, "\u0639\u0645\u0644\u06CC\u0627\u062A"))), _react["default"].createElement(_core.TableBody, null, files.slice(page * rowsPerPage, page * rowsPerPage + rowsPerPage).map(function (file, index) {
    return _react["default"].createElement(StyledTableRow, {
      key: index
    }, _react["default"].createElement(StyledTableCell, {
      align: "center"
    }, index + 1), _react["default"].createElement(StyledTableCell, {
      align: "center"
    }, file.type.includes("image") ? _react["default"].createElement("img", {
      width: "36",
      height: "36",
      src: URL.createObjectURL(file)
    }) : file.type.includes("application/pdf") ? _react["default"].createElement(_react2["default"], {
      size: 1,
      path: _js.mdiFilePdf,
      color: "#ee453e"
    }) : file.type.includes(".document") ? _react["default"].createElement(_react2["default"], {
      size: 1,
      path: _js.mdiFileWord,
      color: "#009ce6"
    }) : file.type.includes(".sheet") ? _react["default"].createElement(_react2["default"], {
      size: 1,
      path: _js.mdiFileExcel,
      color: "#7fd41b"
    }) : file.type), _react["default"].createElement(StyledTableCell, {
      align: "center"
    }, file.path), _react["default"].createElement(StyledTableCell, {
      align: "center"
    }, Math.round(file.size / 1024).toFixed(0), "\u06A9\u06CC\u0644\u0648\u0628\u0627\u06CC\u062A"), _react["default"].createElement(StyledTableCell, {
      align: "center"
    }, processIndex === index ? _react["default"].createElement(_core.CircularProgress, {
      color: "primary",
      variant: "determinate",
      value: completed
    }) : null), _react["default"].createElement(StyledTableCell, {
      align: "center"
    }, _react["default"].createElement(_core.IconButton, {
      onClick: function onClick() {
        removeItem(file.name);
      }
    }, _react["default"].createElement(_core.Tooltip, {
      title: "\u062D\u0630\u0641 \u0622\u06CC\u062A\u0645",
      placement: "top"
    }, _react["default"].createElement(_icons.Delete, {
      className: classes.textError
    }))), autoUpload || hideButtons ? completedIndexes.find(function (item) {
      return item.name === file.name;
    }) ? _react["default"].createElement(_icons.Check, {
      className: classes.textSuccess
    }) : null : completedIndexes.find(function (item) {
      return item.name === file.name;
    }) ? _react["default"].createElement(_icons.Check, {
      className: classes.textSuccess
    }) : _react["default"].createElement(_core.IconButton, {
      onClick: function onClick() {
        uploaderHandler(index);
      }
    }, _react["default"].createElement(_core.Tooltip, {
      title: "\u0628\u0627\u0631\u06AF\u0632\u0627\u0631\u06CC \u0622\u06CC\u062A\u0645",
      placement: "top"
    }, _react["default"].createElement(_icons.CloudUploadOutlined, {
      className: classes.textInfo
    })))));
  }))), _react["default"].createElement(_core.TablePagination, {
    rowsPerPageOptions: [5, 10, 25],
    component: "div",
    count: files.length,
    rowsPerPage: rowsPerPage,
    page: page,
    backIconButtonProps: {
      'aria-label': 'صفحه قبلی'
    },
    nextIconButtonProps: {
      'aria-label': 'صفحه بعدی'
    },
    labelRowsPerPage: "\u062A\u0639\u062F\u0627\u062F \u0631\u06A9\u0648\u0631\u062F \u062F\u0631 \u0635\u0641\u062D\u0647:",
    labelDisplayedRows: function labelDisplayedRows(paginationInfo) {
      return "نمایش رکورد" + paginationInfo.from + "تا" + paginationInfo.to + "از" + paginationInfo.count + "رکورد";
    },
    onChangePage: handleChangePage,
    onChangeRowsPerPage: handleChangeRowsPerPage
  }), _react["default"].createElement("div", {
    className: classes.formButtonSection
  }, autoUpload || hideButtons ? null : _react["default"].createElement(_core.Badge, {
    color: "primary",
    badgeContent: files.length - completedIndexes.length,
    className: classes.margin
  }, _react["default"].createElement(_core.Button, {
    disabled: files.length === completedIndexes.length,
    color: "primary",
    onClick: function onClick() {
      uploaderHandler(null);
    },
    variant: "outlined",
    size: "medium",
    style: {
      padding: "5px 8px",
      margin: 0
    }
  }, _react["default"].createElement(_icons.CloudUploadOutlined, {
    style: {
      margin: '0 4px'
    }
  }), "\u0628\u0627\u0631\u06AF\u0632\u0627\u0631\u06CC \u0647\u0645\u0647")), _react["default"].createElement(_core.Badge, {
    color: "primary",
    badgeContent: state.files.length,
    className: classes.margin
  }, _react["default"].createElement(_core.Button, {
    disabled: files.length === 0,
    className: classes.errorButtonOutLine,
    onClick: removeAll,
    variant: "outlined",
    size: "medium"
  }, _react["default"].createElement(_icons.Delete, {
    style: {
      margin: '0 4px'
    }
  }), "\u062D\u0630\u0641 \u0647\u0645\u0647"))))));
}

Uploader.contextTypes = {
  translate: _propTypes["default"].func
};
Uploader.propTypes = {
  classes: _propTypes["default"].object.isRequired,
  multiple: _propTypes["default"].bool,
  minSize: _propTypes["default"].number,
  maxSize: _propTypes["default"].number,
  autoUpload: _propTypes["default"].bool,
  hideButtons: _propTypes["default"].bool,
  returnItems: _propTypes["default"].func,
  responseStatus: _propTypes["default"].func,
  uploadUrl: _propTypes["default"].string.isRequired,
  showAlert: _propTypes["default"].bool
};

var _default = (0, _core.withStyles)(_style.styles)(Uploader);

exports["default"] = _default;